//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_fsc_cure;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import sim.access.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class FWK_FSC_CURE_1 extends TestToolkitApplet {

    SIMView theSimView;

    final static byte  CMD_QUALIFIER = (byte)0x01; //alphabet set;
    final static byte  DATA_CODING   = (byte)0x0F; //language unspecified
    final static byte[] DISPLAY_TEXT = {(byte)'w', (byte)'a', (byte)'i', (byte)'t'};

    final static short BUFFER_LENGTH = (short)20;
    byte[] resp1 = new byte[BUFFER_LENGTH];
    byte[] resp2 = new byte[BUFFER_LENGTH];


    /**
     * The Constructor registers the application for the Event.
     */
    private FWK_FSC_CURE_1() {

        // Get a reference to the SIM View.
        theSimView = SIMSystem.getTheSIMView();

    }


    public static void install(byte[] bArray, short bOffset, byte bLength) {
        FWK_FSC_CURE_1 testApp = new FWK_FSC_CURE_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }


    /**
     * This method will be used to trigger the tests.
     * The application will be triggered by an Formatted SMS PP download event.
     * @param event
     */
    public void processToolkit (byte event) throws ToolkitException {

        if (event == EVENT_FORMATTED_SMS_PP_ENV) {
            /*------------------------------------------------------------------
             * TEST CASE 01: Seek without affecting another record pointer
             *----------------------------------------------------------------*/
            try {
                testApplet1();
                reportTestSuccess((byte)TestConstants.TESTCASE01);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }

            /*------------------------------------------------------------------
             * TEST CASE 02: updateRecord in linear fixed EF without affecting
             *               current pointer of others.
             *----------------------------------------------------------------*/
            try {
                testApplet1();
                reportTestSuccess((byte)TestConstants.TESTCASE02);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE02);
            }

            /*------------------------------------------------------------------
             * TEST CASE 03: readRecord in linear fixed EF without affecting
             *               current pointer of others.
             *----------------------------------------------------------------*/
            try {
                testApplet1();
                reportTestSuccess((byte)TestConstants.TESTCASE03);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }

        } // end: if (event)...
    }


    void testApplet1() throws UserException {

        short result;
        short respLength;
        byte  mode;
        ProactiveHandler proHdlr;

        proHdlr = ProactiveHandler.getTheHandler();
        respLength = (short)4;

        // (1/3) - No exception shall be thrown.
        theSimView.select(TestConstants.FID_DF_SIMTEST);
        theSimView.select(TestConstants.FID_EF_LARU);

        // Record pointer not set, will be set to record 2...
        mode = SIMView.REC_ACC_MODE_NEXT;
        theSimView.readRecord((short)0, mode, (short)0, resp1, (short)0, respLength);
        theSimView.readRecord((short)0, mode, (short)0, resp1, (short)0, respLength);
        // record pointer is now pointing at record 2

        // issue a proactive command (GET INKEY)
        proHdlr.initGetInkey(CMD_QUALIFIER, DATA_CODING, DISPLAY_TEXT,
                                            (short)0, (short)DISPLAY_TEXT.length);
        result = proHdlr.send();

        // (3/3) - No exception shall be thrown.
        // read back the record and check if the result is the same
        // (record pointer was not altered)
        mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
        theSimView.readRecord((short)0, mode, (short)0, resp2, (short)0, respLength);

        if (Util.arrayCompare(resp1, (short)0, resp2, (short)0, respLength)!=0) {
            UserException.throwIt((short)0);
        }

    }

}
