//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_fsc_init;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.access.*;
import sim.toolkit.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;
 
public class FWK_FSC_INIT_1 extends TestToolkitApplet {

    public final static byte[] MF = {(byte) 0x3F, (byte) 0x00, (byte) 0x01};
    public final static short OFFSET_FID = (short)4;
    public static byte[] fci = new byte[10];

    private static SIMView theSIMView;
    private ToolkitRegistry tlkReg;

    /**
     * The Constructor register the application for the Event.
     */
    private FWK_FSC_INIT_1() {

        // Get a reference to the SIM View.
        theSIMView = SIMSystem.getTheSIMView();

        //Register the event EVENT_EVENTDOWNLOAD_USER_ACTIVITY
        tlkReg = ToolkitRegistry.getEntry();
        tlkReg.setEvent(ToolkitConstants.EVENT_EVENT_DOWNLOAD_USER_ACTIVITY);

    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        FWK_FSC_INIT_1 testApp = new FWK_FSC_INIT_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }

    /**
     * @param event
     * In the processToolkit-function the incomming data will be processed.
     * In accordance to the tags of the TLVs, there will be processed a
     * GetInkeyCommand or an UPDATECommand. The GetInkeyCommand will be also
     * used to test the of the ProactiveResponseHandler.
     */
    public void processToolkit (byte event) throws ToolkitException {

        short fciOffset = 0;
        short fciLength = 0;
        short result;

        if (event == ToolkitConstants.EVENT_FORMATTED_SMS_PP_ENV) {

            /*------------------------------------------------------------------
             * TEST CASE 01: MF is the initial default selected file
             *----------------------------------------------------------------*/
            try {
                // No exception shall be thrown. Shall return 7.
                // fci shall contain the following part of the FCI structure:
                // < XX XX XX XX 3F 00 01 >
                fciOffset = 0;
                fciLength = 7;
                result = theSIMView.status(fci, fciOffset, fciLength);
                if ((result != fciLength)
                    || (Util.arrayCompare(MF, (short)0, fci, OFFSET_FID, (short)MF.length)!=0))
                {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE01);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }

            /*------------------------------------------------------------------
             * TEST CASE 02: No EF is selected
             *----------------------------------------------------------------*/
            try {
                try {
                    // SIMView exception shall be thrown with reason NO_EF_SELECTED
                    theSIMView.rehabilitate();
                    UserException.throwIt((short)0);
                } catch (SIMViewException sve) {
                    reportTestOutcome((byte)TestConstants.TESTCASE02,
                        sve.getReason() == SIMViewException.NO_EF_SELECTED);
                }
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE02);
            }
        } // end if event EVENT_FORMATTED_SMS_PP_ENV


        if (event == ToolkitConstants.EVENT_EVENT_DOWNLOAD_USER_ACTIVITY) {
            /*------------------------------------------------------------------
             * TEST CASE 03: MF is selected evenwhen a applet triggered before
             *               selected any other file...
             *----------------------------------------------------------------*/
            try {
                // 1 - No exception shall be thrown.
                theSIMView.select(SIMView.FID_DF_GSM);
                theSIMView.select(SIMView.FID_EF_IMSI);
                reportTestSuccess((byte)TestConstants.TESTCASE03);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }
        } // end if event EVENT_EVENT_DOWNLOAD_USER_ACTIVITY
    }
}
